"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var tinycolor = require("tinycolor2");
var RED = "rgba(255, 0, 0, 0.1)";
function create(value) {
    return tinycolor(value);
}
exports.create = create;
exports.black = function () { return create('black'); };
exports.white = function () { return create('white'); };
function format(value) {
    if (value === true) {
        return RED;
    }
    if (R.is(Number, value)) {
        return toGrayAlpha(value);
    }
    return value;
}
exports.format = format;
function toGrayAlpha(value) {
    if (value < -1) {
        value = -1;
    }
    if (value > 1) {
        value = 1;
    }
    if (value < 0) {
        return "rgba(0, 0, 0, " + Math.abs(value) + ")";
    }
    if (value > 0) {
        return "rgba(255, 255, 255, " + value + ")";
    }
    return "rgba(0, 0, 0, 0.0)";
}
exports.toGrayAlpha = toGrayAlpha;
function toGrayHex(value) {
    if (value < -1) {
        value = -1;
    }
    if (value > 1) {
        value = 1;
    }
    if (value < 0) {
        return exports.white()
            .darken(Math.abs(value) * 100)
            .toHexString();
    }
    if (value > 0) {
        return exports.black()
            .lighten(value * 100)
            .toHexString();
    }
    return exports.white().toHexString();
}
exports.toGrayHex = toGrayHex;
//# sourceMappingURL=color.js.map