"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("../../common");
var alignment_1 = require("../../common/alignment");
exports.AlignmentContainer = function (props) {
    var _a = alignment_1.edges(props.align || 'top center', 'center', 'top'), horizontal = _a.horizontal, vertical = _a.vertical;
    var direction = '';
    var alignItems = '';
    var justifyContent = '';
    if (horizontal === 'left' && vertical === 'top') {
        direction = 'row';
        alignItems = 'flex-start';
    }
    if (horizontal === 'left' && vertical === 'middle') {
        direction = 'row';
        alignItems = 'center';
    }
    if (horizontal === 'left' && vertical === 'bottom') {
        direction = 'row';
        alignItems = 'flex-end';
    }
    if (horizontal === 'right' && vertical === 'top') {
        direction = 'column';
        alignItems = 'flex-end';
    }
    if (horizontal === 'right' && vertical === 'middle') {
        direction = 'row';
        alignItems = 'center';
        justifyContent = 'flex-end';
    }
    if (horizontal === 'right' && vertical === 'bottom') {
        direction = 'column-reverse';
        alignItems = 'flex-end';
    }
    if (horizontal === 'center' && vertical === 'top') {
        direction = 'column';
        alignItems = 'center';
    }
    if (horizontal === 'center' && vertical === 'middle') {
        direction = 'column';
        alignItems = 'center';
        justifyContent = 'center';
    }
    if (horizontal === 'center' && vertical === 'bottom') {
        direction = 'column-reverse';
        alignItems = 'center';
    }
    var styles = {
        base: common_1.css({
            alignItems: alignItems,
            justifyContent: justifyContent,
            Absolute: 0,
            display: 'flex',
            flexDirection: direction,
        }),
    };
    return common_1.React.createElement("div", __assign({}, styles.base), props.children);
};
//# sourceMappingURL=AlignmentContainer.js.map